class Sbst {
	Term term;
	Term variable;
	
	public Sbst() {
		term = new Term();
		variable = new Term();
	}
	
	public Sbst(Term t, Term v) {
		term = t.duplicate();
		variable = v.duplicate();
	}
	
	public String toString() {
		return "[" + term + "/" + variable + "]";
	}

	void setTerm(Term t) {
		this.term = t.duplicate();
	}
	
	void setVariable(Term v) {
		this.variable = v.duplicate();
	}

	boolean equals(Sbst sbst) {
		if (this.term.equals(sbst.term) && this.variable.equals(sbst.variable)) {
			return true;
		}
		return false;
	}
	
	boolean consistentWith(Sbst sbst) {
		if (this.term.equals(sbst.term) || !this.variable.equals(sbst.variable)) {
			return true;
		}
		return false;
	}
	
	Sbst duplicate() {
		Sbst sbst = new Sbst();
		sbst.term = this.term.duplicate();
		sbst.variable = this.variable.duplicate();
		return sbst;
	}
	
	void avoidVariableClash() {
		this.term.avoidVariableClash();
	}
	
	void undoAvoidVariableClash() {
		this.term.undoAvoidVariableClash();
	}
	
	SbstSet composite(Sbst sbst) {
		SbstSet sset = new SbstSet();
		Sbst sbst2 = new Sbst();
		sbst2 = this.duplicate();
		sbst2.term = this.term.substitute(sbst);
		sset.add(sbst2);
		sset.add(sbst);
		return sset;
	}
	
	static void main(String[] args) {
	}
}
