import java.util.*;
class Term {
	int kind;
	int index;
	int arity;
	Term[] arguments;
	
	public Term() {
		kind = 0;
		index = 0;
		arity = 0;
		arguments = new Term[0];
	}
	
	public Term(int k, int i) {
		kind = k;
		index = i;
		arity = 0;
		arguments = new Term[0];
	}
	
	public Term(int k, int i, int a) {
		kind = k;
		index = i;
		arity = a;
		for (int j = 0; j < a; j++) {
			Tuple t = new Tuple();
		}
		arguments = new Term[a];
	}
	
	public String toString() {
		if (kind == -1) {
			return "*" + index;
		}
		if (kind == 0) {
			return "v" + index;
		} else if (kind == 1) {
			if (arity == 0) {
				return "c" + index;
			} else {
				String args = "";
				for (int i = 0; i < arity - 1; i++) {
					args += arguments[i] + ", ";
				}
				args += arguments[arity - 1];
				return "f" + index + "(" + args + ")";
			}
		} else {
			if (arity == 0) {
				return "p" + index;
			} else {
				String args = "";
				for (int i = 0; i < arity - 1; i++) {
					args += arguments[i] + ", ";
				}
				args += arguments[arity - 1];
				return "P" + index + "(" + args + ")";
			}
		}
	}
	
	//̍\TupleԂD
	Tuple skelton() {
		Tuple s = new Tuple();
		for (int i = 0; i < this.arity; i++) {
			s.add(this.arguments[i].skelton());
		}
		return s;
	}

	//thisiԖڂ̈Ƃt͂D
	void setArgument(int i, Term t) {
		this.arguments[i] = t;
	}
	
	//this̈ʒupɂ鍀ԂD
	Term pickUp(ArrayList<Integer> p) {
		Term t = new Term();
		t = this.duplicate();
		for (int i = 0; i < p.size(); i++) {
			if (p.get(i) == 0) {
				break;
			} else {
				t = t.arguments[p.get(i) - 1];
			}
		}
		return t;
	}
	
	boolean agreeModuloArguments(Term t) {
		if (this.kind == t.kind) {
			if (this.index == t.index) {
				if (this.arity == t.arity) {
					return true;
				}
				return false;
			}
			return false;
		}
		return false;
	}
	
	boolean equals(Term t) {
		if (this.kind == t.kind) {
			if (this.kind == 0) {
				if (this.index == t.index) {
					return true;
				}
				return false;
			}
			if (this.index == t.index && this.arity == t.arity) {
				for (int i = 0; i < this.arity; i++) {
					if (!this.arguments[i].equals(t.arguments[i])) {
						return false;
					}
				}
				return true;
			}
			return false;
		}
		return false;
	}
	
	//𕡐D
	Term duplicate() {
		Term t = new Term(this.kind, this.index, this.arity);
		for (int i = 0; i < this.arity; i++) {
			t.setArgument(i, this.arguments[i].duplicate());
		}
		return t;
	}

	//u
	Term substitute(Sbst sbst) {
		if (this.kind == 0) {
			Term t = new Term();
			if (sbst.variable.equals(this)) {
				t = sbst.term.duplicate();
				return t;
			}
			t = this.duplicate();
			return t;
		} else {
			Term t = new Term(this.kind, this.index, this.arity);
			for (int i = 0; i < this.arity; i++) {
				t.setArgument(i, this.arguments[i].substitute(sbst));
			}
			return t;
		}
	}
	
	//thist̕ł邩𔻒肷D
	boolean subTerm(Term t) {
		if (this.equals(t)) {
			return true;
		}
		for (int i = 0; i < t.arity; i++) {
			if (this.subTerm(t.arguments[i])) {
				return true;
			}
		}
		return false;
	}

	//thistɂʒuԂD
	ArrayList<Integer> place(Term t) {
		ArrayList<Integer> p = new ArrayList<Integer>();
		if (!this.subTerm(t)) {
			return p;
		}
		if (this.equals(t)) {
			p.add(0);
			return p;
		}
		int n = 1;
		for (int i = 0; i < t.arity; i++) {
			if (!this.subTerm(t.arguments[i])) {
				n++;
			} else {
				ArrayList<Integer> pp = new ArrayList<Integer>();
				pp = this.place(t.arguments[i]);
				p.add(n);
				for (int j = 0; j < pp.size(); j++) {
					p.add(pp.get(j));
				}
				break;
			}
		}
		return p;
	}
	
	//ϐkind-1ɂD
	void avoidVariableClash() {
		if (this.kind == 0) {
			this.kind = -1;
		}
		for (int i = 0; i < this.arity; i++) {
			this.arguments[i].avoidVariableClash();
		}
	}
	//kind-1ɂȂĂ鍀0ɒD
	void undoAvoidVariableClash() {
		if (this.kind == -1) {
			this.kind = 0;
		}
		for (int i = 0; i < this.arity; i++) {
			this.arguments[i].undoAvoidVariableClash();
		}
	}
	
	//uD
	Term substituteAtOnce(SbstSet sset) {
		Term t = new Term();
		t = this.duplicate();
		for (int i = 0; i < sset.size; i++) {
			sset.sbsts.get(i).avoidVariableClash();
		}
		for (int i = 0; i < sset.size; i++) {
			t = t.substitute(sset.sbsts.get(i));
		}
		for (int i = 0; i < sset.size; i++) {
			sset.sbsts.get(i).undoAvoidVariableClash();
		}
		t.undoAvoidVariableClash();
		return t;
	}
	
	//̍svWD
	TermSet disagreementSet(Term t) {
		TermSet dset = new TermSet();
		if (this.kind != t.kind) {
			dset.add(this);
			dset.add(t);
			return dset;
		} else if (this.arity != t.arity) {
			dset.add(this);
			dset.add(t);
			return dset;
		} else if (this.index != t.index) {
			dset.add(this);
			dset.add(t);
			return dset;
		} else {
			int i = 0;
			while (dset.isEmpty() && i < this.arity) {
				dset = this.arguments[i].disagreementSet(t.arguments[i]);
				i++;
			}
			return dset;
		}
	}

	//PꉻASỸeXgD
	//̍炻̍ŔēqimgujD
	//Pꉻ\łȂnullԂD
	SbstSet unifierTest(Term t) {
		Term tt1 = this.duplicate();
		Term tt2 = t.duplicate();
		TermSet dset = new TermSet();
		dset = tt1.disagreementSet(tt2);
		SbstSet mgu = new SbstSet();
		while (!dset.isEmpty()) {
			System.out.println("debug print: dset = " + dset);
			int n = -1;
			for (int i = 0; i < dset.size; i++) {
				if (dset.get(i).kind == 0) {
					n = i;
					break;
				}
			}
			if (n == -1) {
				return null;
			}
			for (int i = 0; i < dset.size; i++) {
				if (i != n) {
					if (!dset.get(n).equals(dset.get(i))) {
						if (dset.get(n).subTerm(dset.get(i))) {
							System.out.println("debug print: " + dset.get(n) + " is a subterm of " + dset.get(i));
							System.out.println("debug print: ununifiable");
							return null;
						}
					}
				}
			}
			Sbst sbst = new Sbst();
			if (n == 0) {
				sbst.variable = dset.get(0);
				sbst.term = dset.get(1);
			} else {
				sbst.variable = dset.get(n);
				sbst.term = dset.get(0);
			}
			tt1 = tt1.substitute(sbst);
			tt2 = tt2.substitute(sbst);
			SbstSet sset = new SbstSet();
			sset.add(sbst);
			mgu = mgu.composite(sset);
			System.out.println("debug print: mgu = " + mgu);
			dset = tt1.disagreementSet(tt2);
		}
		System.out.println("debug print: unifiable");
		return mgu;
	}

	//PꉻASYD
	//̍炻̍ŔēqimgujD
	//Pꉻ\łȂnullԂD
	SbstSet unifier(Term t) {
		Term tt1 = this.duplicate();
		Term tt2 = t.duplicate();
		TermSet dset = new TermSet();
		dset = tt1.disagreementSet(tt2);
		SbstSet mgu = new SbstSet();
		while (!dset.isEmpty()) {
			int n = -1;
			for (int i = 0; i < dset.size; i++) {
				if (dset.get(i).kind == 0) {
					n = i;
					break;
				}
			}
			if (n == -1) {
				return null;
			}
			for (int i = 0; i < dset.size; i++) {
				if (i != n) {
					if (!dset.get(n).equals(dset.get(i))) {
						if (dset.get(n).subTerm(dset.get(i))) {
							return null;
						}
					}
				}
			}
			Sbst sbst = new Sbst();
			if (n == 0) {
				sbst.variable = dset.get(0);
				sbst.term = dset.get(1);
			} else {
				sbst.variable = dset.get(n);
				sbst.term = dset.get(0);
			}
			tt1 = tt1.substitute(sbst);
			tt2 = tt2.substitute(sbst);
			SbstSet sset = new SbstSet();
			sset.add(sbst);
			mgu = mgu.composite(sset);
			dset = tt1.disagreementSet(tt2);
		}
		return mgu;
	}
	
	boolean unifiable(Term t) {
		if (this.unifier(t) == null) {
			return false;
		}
		return true;
	}
	
	TermSet freeVariableSet() {
		Term t = new Term();
		t = this.duplicate();
		TermSet tset = new TermSet();
		if (t.kind == 0) {
			tset.add(t);
			return tset;
		}
		for (int i = 0; i < t.arguments.length; i++) {
			tset = tset.union(t.arguments[i].freeVariableSet());
		}
		return tset;
	}

	public static void main(String[] args) {
		Term v1 = new Term(0, 1);
		Term v2 = new Term(0, 2);
		Term v3 = new Term(0, 3);
		Term c1 = new Term(1, 1, 0);
		Term c2 = new Term(1, 2, 0);
		Term c3 = new Term(1, 3, 0);
		Term f1 = new Term(1, 1, 1);
		Term f2 = new Term(1, 2, 2);
		Term f3 = new Term(1, 2, 2);
		Term P1 = new Term(2, 1, 3);
		f1.setArgument(0, v2);
		f2.setArgument(0, v1);
		f2.setArgument(1, f1);
		f3.setArgument(0, v3);
		f3.setArgument(1, f1);
		P1.setArgument(0, c1);
		P1.setArgument(1, f3);
		P1.setArgument(2, f2);
		Sbst sbst1 = new Sbst();
		Sbst sbst2 = new Sbst();
		Sbst sbst3 = new Sbst();
		Sbst sbst4 = new Sbst();
		sbst1.setTerm(f1);
		sbst1.setVariable(v1);
		sbst2.setTerm(v3);
		sbst2.setVariable(v2);
		sbst3.setTerm(c1);
		sbst3.setVariable(v1);
		sbst4.setTerm(c1);
		sbst4.setVariable(v3);
		SbstSet sset1 = new SbstSet();
		SbstSet sset2 = new SbstSet();
		sset1.add(sbst1);
		sset1.add(sbst2);
		sset2.add(sbst3);
		sset2.add(sbst4);
		System.out.println(f2);
		System.out.println(sbst1);
		System.out.println(sbst2);
		System.out.println(f2.substituteAtOnce(sset1));
		System.out.println(sbst1);
		System.out.println(sbst2);
	}
}
